<?php


	//
	//	This file is part of MythWeb,
	//	a php-based interface into MythTV.
	//
	//	(c) 2002 by Thor Sigvaldason and Isaac Richards
	//	MythWeb is distributed under the
	//	GNU GENERAL PUBLIC LICENSE version 2
	//	(see http://www.gnu.org)
	//


//
//	listings.php is the default mode that
//	shows current listings.
//

//
//	If we got passed a date/time to start and maybe a time offset
//	or (if not) see if we got passed a time offset on the URL (GET)
//	or (if not) use the current system time.
//
if(isset($_GET["date"]))
{
	$theOffset = 0;
	$idate = $_GET["date"];
	$ihour = $_GET["hour"];
	$sqlstarttime = $idate.$ihour."0000";

	$time = parseTime($sqlstarttime);
	if(isset($_GET["timeoffset"]))
	{
		$theOffset = $_GET["timeoffset"];
		$adjuster = round(30 * $timeSlots * $_GET["timeoffset"]);
		$sqlstarttime = date("YmdHis", mktime($time["hour"], 0 + $adjuster,0,$time["month"],$time["day"],$time["year"]));
		$idate = date("Ymd", mktime($time["hour"], 0 + $adjuster,0,$time["month"],$time["day"],$time["year"]));
		$ihour = date("H", mktime($time["hour"], 0 + $adjuster,0,$time["month"],$time["day"],$time["year"]));
		$theOffset=0;
	}
}
elseif(isset($_GET["timeoffset"]))
{
	$theOffset = $_GET["timeoffset"];
	$adjuster = round(30 * $timeSlots * $_GET["timeoffset"]);
	$sqlstarttime = date("YmdHis", mktime(date(H), date(i) + $adjuster,date(s),date(m),date(d),date(Y)));
	$idate = date("Ymd", mktime(date(H), date(i) + $adjuster,date(s),date(m),date(d),date(Y)));
	$ihour = date("H", mktime(date(H), date(i) + $adjuster,date(s),date(m),date(d),date(Y)));
}
elseif(isset($_GET["datetime"]))
{
	$theOffset = 0;
	$sqlstarttime=$_GET["datetime"];
	$time = parseTime($sqlstarttime);
	$idate = $time["year"].$time["month"].$time["day"];
	$ihour = $time["hour"];
}
else
{
	$sqlstarttime = date('YmdHis');
	$idate = date('Ymd');
	$ihour = date('H');
	$theOffset = 0;
}


//
//	Build some data structures
//	(channels, programs, etc.)
//
$timearray = setupTimes($sqlstarttime, $timeSlots);
$channelarray = setupChannels();
$programarray = setupPrograms($channelarray, $timearray, $timeSlots);

//	Put out the date/time adjust fields
echo "<center>";
echo "<form action=\"main.php\" method=\"get\">";
echo "Jump to:&nbsp;&nbsp;&nbsp; Hour:";
echo "<input type=\"hidden\" name=\"mode\" value=\"listings\">";
echo "<select name=hour>";
for ($i=0;$i<24;$i++)
{
	$h = sprintf("%02d",$i);
	echo "<option value=$h ";
	if ("$h"=="$ihour") echo "selected";
	echo ">$h:00</option>";
}
echo "</select>";
echo "&nbsp;&nbsp;Date:";
echo "<select name=date>";
for ($i=-1;$i<14;$i++)
{
	$year = date('Y');
	$month = date('m');
	$day = date('d');
	$date = date("Ymd",mktime(0,0,0,$month,$day+$i,$year));
	$date2 = date($date_format,mktime(0,0,0,$month,$day+$i,$year));
	echo "<option value=$date ";
	if ($date==$idate) echo "selected";
	echo ">$date2</option>";
}
echo "</select>";
echo "&nbsp;&nbsp;&nbsp;<input type=submit value=Jump>";
echo "</form>";
echo "</center>";

//
//	Start outputing. First a big
//	table in the "background" colour just to
//	set the colour and show the lines 
//	between programs
//	
print("\n\n\t\t<TABLE WIDTH=\"100%\" BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\" BGCOLOR=\"$list_bg_colour\">\n\t\t\t<TR>\n\t\t\t\t<TD>\n");

//
//	A second table where the actual <TR><TD>
//	data goes (with CELLSPACING "holes" to
//	see the background colour through)
//
print("\t\t\t\t\t<TABLE WIDTH=\"100%\" BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"1\" BGCOLOR=\"$list_bg_colour\">\n");

//
//	A full width cell that display the date
//
print("\t\t\t\t\t\t<TR>\n\t\t\t\t\t\t\t<TD>\n\t\t\t\t\t\t\t</TD>\n\t\t\t\t\t\t\t<TD ALIGN=\"CENTER\" COLSPAN=\"$timeSlots\" BGCOLOR=\"$list_fg_colour\">\n\t\t\t\t\t\t\t\t");
printTheDate($sqlstarttime, $theOffset, $timeSlots);
print("\n\t\t\t\t\t\t\t</TD>\n\t\t\t\t\t\t</TR>\n");

//
//	Left arrow to go back in time
//	(if only it were that easy)
//
print("\t\t\t\t\t\t<TR>\n");
$pastOffset = $theOffset - 1;
$futureOffset = $theOffset + 1;
print("<TD><A HREF=\"main.php?mode=listings&date=$idate&hour=$ihour&timeoffset=$pastOffset#anchor$anchor\"><IMG SRC=\"images/left.gif\" BORDER=\"0\" ALT=\"left\"></A></td>\n");


//
//	The headings for the time columns
//
for ($timeslot = 0; $timeslot < $timeSlots; $timeslot += 1)
{
    $theTime = $timearray[$timeslot];
    $theTime->setColour($text_dark, $list_fg_colour);
    $theTime->printYourself();
}

//
//	Right arrow to go forward in time
//
print "<TD><A HREF=\"main.php?mode=listings&date=$idate&hour=$ihour&timeoffset=$futureOffset#anchor$anchor\"><IMG SRC=\"images/right.gif\" BORDER=\"0\" ALT=\"right\"></A></TD>";
print "\t</tr>\n";

//
//	Sort down by channels and across by program
//
$channelindex = 0;
$timebar = 0;
$anchor = 0;
while ($mychannel = $channelarray[$channelindex])
{
	// print out channel num, callsign and icon
	print("\t\t<TR><td><center><font size=\"-1\"><a style=\"color:$menu_fg_colour\" href=\"main.php?mode=bychannel&chanid=$mychannel->chanid\">$mychannel->channum $mychannel->callsign</a></font>");
	if ($includeIcon && is_file($mychannel->icon)) print("<br><img src=\"$mychannel->icon\">");
	print("</center></td>\n");

	// print out channel row of programs
	$lasttitle = " ";
	$lastsubtitle = " ";
	$lastendts = 0;
	for ($timeslot = 0; $timeslot < $timeSlots; $timeslot += 1)
	{
		$proginfo = $programarray[$channelindex][$timeslot];

                if ($proginfo == null)
                    continue;

		$finalColour = $list_default_colour;
		if ($proginfo->endts != $lastendts)
		{
			$cellwidth = 1;
			for ($testnext = $timeslot + 1; $testnext < $timeSlots; $testnext += 1)
			{
				//
				//	Try and figure out how long something
				//	is in 30 minute segments
				//
				$testproginfo = $programarray[$channelindex][$testnext];
				if ($testproginfo->startts == $proginfo->startts && $testproginfo->endts == $proginfo->endts)
					$cellwidth++;
				else break;

			}
			if($proginfo->smellsLikeMovie())
				$finalColour = $movie_colour;
			else
				$finalColour = $colorArray[$proginfo->progType];
			if ($finalColour == "")
				$finalColour = $list_default_colour;
			if($proginfo->willRecord())
				$proginfo->setColours($list_reccolour, $finalColour);
			else
				$proginfo->setColours($finalColour, $finalColour);

			$proginfo->printYourself($cellwidth, $theOffset);
		}
		$lasttitle = $proginfo->title;
		$lastsubtitle = $proginfo->subtitle;
		$lastendts = $proginfo->endts;
	}
	print "\t</tr>\n";

	if (($channelindex + 1) % $timeBarCount == 0 ) {
		$anchor++;
		print("<tr><td><a name='anchor$anchor'");
		print("<A HREF=\"main.php?mode=listings&date=$idate&hour=$ihour&timeoffset=$pastOffset#anchor$anchor\"><IMG SRC=\"images/left.gif\" BORDER=\"0\" ALT=\"left\"></A></td>");
		for ($timeslot = 0; $timeslot < $timeSlots; $timeslot += 1) {
			$theTime = $timearray[$timeslot];
		    $theTime->setColour($text_dark, $list_fg_colour);
			$theTime->printYourself();
		}
		$timebar = 0;
		print("<td><A HREF=\"main.php?mode=listings&date=$idate&hour=$ihour&timeoffset=$futureOffset#anchor$anchor\"><IMG SRC=\"images/right.gif\" BORDER=\"0\" ALT=\"right\"></A>");
		print "</td></tr>";
	}

	$channelindex += 1;
	$timebar += 1;

	//if ($channelindex>15) break;	// put in for quick testing...
}
print "</TABLE></TD></TR></TABLE>\n";


?>
